start:
codeStart: 
    jmp  start0    ; 0x03 bytes |  EB 58 90  00 Jump to boot code
    times 3 - ($ - $$) nop        ; fill with 1 or 0 no-ops to address 3
    ; BIOS boot parameter table = 0x25 bytes
    db 'cf2018 0'      ; 03 Eight byte OEM name                                                                                                                                                                                                                                                                  
    dw 0x0200          ; 11 Number of Bytes Per Sector                                                                                                                                                                                                                                                            
    db 0x08            ; 13 Number of Sectors Per Cluster                                                                                                                                                                                                                                                         
    dw 0x05E0          ; 14 Number of Reserved Sectors until the FAT                                                                                                                                                                                                                                              
    db 0x02            ; 16 Number of Copies of FAT : always = 2                                                                                                                                                                                                                                                  
    dw 0x0000          ; 17 Maximum number of Root Directory Entries                                                                                                                                                                                                                                              
    dw 0x0000          ; 19 Not used for FAT32                                                                                                                                                                                                                                                                    
    db 0xF8            ; 21 Media type F0 = 1.44M 3.5 inch floppy disk, F8 = hard disk                                                                                                                                                                                                                            
    dw 0x0000          ; 22 Sectors Per FAT for FAT12 and FAT16 - not used for FAT32                                                                                                                                                                                                                              
    dw 0x003F          ; 24 Sectors per Track                                                                                                                                                                                                                                                                     
    dw 0x00FF          ; 26 Number of heads                                                                                                                                                                                                                                                                       
    dd 0x00000038      ; 28 Hidden sectors preceding the partition that contains this FAT volume                                                                                                                                                                                                                  
    dd 0x007477C8      ; 32                                                                                                                                                                                                                                                                                       
    dd 0x00001D10      ; 36 Sectors Per FAT for FAT32                                                                                                                                                                                                                                                             
    dw 0x0000          ; 40                                                                                                                                                                                                                                                                                       
    dw 0x0000          ; 42                                                                                                                                                                                                                                                                                       
    dd 0x00000002      ; 44 Start of all directories, including root.                                                                                                                                                                                                                                             
    dw 0x0001          ; 48                                                                                                                                                                                                                                                                                       
    dw 0x0006          ; 50 Offset in sectors from this sector to the backup BPB sector                                                                                                                                                                                                                           
;    times 12 db 0      ; 0x0C bytes |  00 00 00 00 00 00 00 00 00 00 00 00  52                                                                                                                                                                                                                                    
;    db 0x00            ; 64                                                                                                                                                                                                                                                                                       
;    db 0x00            ; 65                                                                                                                                                                                                                                                                                       
;    db 0x29            ; 66 Extended Boot Signature                                                                                                                                                                                                                                                               
;    dd 0x44444444      ; 67 serial number                                                                                                                                                                                                                                                                                      
;    db 'colorForth '   ; 71 Eleven byte Volume Label                                                                                                                                                                                                                                                              
;    db 'cFblocks'      ; 82 Eight byte File System name        

; ******************************************************************************
; ******************************************************************************
