\ read-line.f  2018 Jun 08  demonstration of use and testing of  READ-LINE 

10000 constant MAX_NUMBER_OF_LINES

: MyFileName ( -- $ )   s" cf2018.nasm" ;

variable NASMfileHandle
0 NASMfileHandle !

: OpenReadFile 
   MyFileName r/o open-file 
   if ." Couldn't open read file "  MyFileName type space  #2001 throw  then
   NASMfileHandle !
;

$200 constant |ReadLineBuffer| 
|ReadLineBuffer| Buffer: ReadLineBuffer         \ the original complete line

: CloseReadFile ( -- )  
   NASMfileHandle @ CLOSE-FILE drop 
   0 NASMfileHandle !
;

: ReadOneLine ( -- f )    \ into the buffer
   ReadLineBuffer 1+ |ReadLineBuffer| NASMfileHandle @ READ-LINE if  
      CloseReadFile  cr ." could not ReadOneLine from file"  #12090 throw
   then
   ( flag ) >r
   dup $FF > if 
      cr 2 attribute  ." ReadOneLine ReadLineBuffer count > $FF, count =  " dup .  0 attribute
      ekey #27 = if ." Escaped!" #12021 throw  then
   then
   ReadLineBuffer c! 
   r> ( flag ) 
;

variable line#

$200 constant |SaveFilename|
|SaveFilename| Buffer: SaveFilename

: Test  ( -- )
   ." \ ProcessNASMfile  text output from NASM file : " MyFileName type   
   cr
   OpenReadFile   
   MAX_NUMBER_OF_LINES 0 do
      1 line# +!
      ReadOneLine 0= if  leave  then
      cr ." line# = "  line# @ 4 u.r  ."  | "  ReadLineBuffer count type
   loop  
   CloseReadFile
   cr ." Done." cr
;

Test

